﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GfxConvert
{
    public interface ISelectionAreaChange
    {
        void changed();
    }

    public class SelectionArea 
    {

        public SelectionArea(ISelectionAreaChange iChanged)
        {
            m_iChanged = null;
            set(0, 0, 16, 16);
            m_iChanged = iChanged;
            m_iChanged.changed();
        }

        public void set(int ix, int iy, int iw, int ih)
        {
            x = ix;
            y = iy;
            w = iw;
            h = ih;
        }

        public void get(out int ix, out int iy, out int iw, out int ih)
        {
            ix = x;
            iy = y;
            iw = w;
            ih = h;
        }

        public void get(float scale, out float ix, out float iy, out float iw, out float ih)
        {
            ix = scale * x;
            iy = scale * y;
            iw = scale * w;
            ih = scale * h;
        }

        public int x
        {
            get
            {
                return m_x;
            }
            set
            {
                if (m_iChanged != null)
                {
                    m_iChanged.changed();
                }
                m_x = value;
            }
        }

        public int y
        {
            get
            {
                return m_y;
            }
            set
            {
                if (m_iChanged != null)
                {
                    m_iChanged.changed();
                }
                m_y = value;
            }
        }

        public int w
        {
            get
            {
                return m_w;
            }
            set
            {
                if (m_iChanged != null)
                {
                    m_iChanged.changed();
                }
                m_w = value;
            }
        }

        public int h
        {
            get
            {
                return m_h;
            }
            set
            {
                if (m_iChanged != null)
                {
                    m_iChanged.changed();
                }
                m_h = value;
            }
        }

        int m_x, m_y;
        int m_w, m_h;
        ISelectionAreaChange m_iChanged;
    };
}
