﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core.components.extMemory.SDCard
{
    public class SDCommandResponse
    {
        Random m_rnd = new Random();

        public SDCommandResponse(UInt16 icmd, UInt16 argh, UInt16 argl)
        {
            crc7 = crc7expected = ((UInt16)(((UInt32)m_rnd.Next()) & 0x7f));
            cmd = icmd;
            arg[7] = argh;
            arg[6] = argl;
            commandPass = true;
        }

        public SDCommandResponse(UInt16 icmd, UInt16[] iarg)
        {
            crc7 = crc7expected = (UInt16)(((UInt32)m_rnd.Next()) & 0x7f);
            cmd = icmd;

            if (iarg.Count() > arg.Count())
            {
                throw new Exception("internal error: SDResponse got to much arguments");
            }

            for (int i = 0; i < iarg.Count(); i++)
            {
                arg[i] = iarg[i];
            }

            commandPass = true;
        }

        public UInt16 cmd;
        public UInt16 crc7;
        public UInt16 crc7expected;
        public UInt16[] arg = new UInt16[8];
        public bool commandPass;

    }
}
