﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_emulator.core.components.stages;
using xcore_tools.Common;

namespace ucore_emulator.core.components.stages_hcore
{
    public class hDCache : bitExtraction, IStage
    {
        const int lineWidthBits = 6;
        const uint lineWidth = (uint)(1 << lineWidthBits);

        UInt32 tag;
        bool[] valids = new bool[lineWidth];
        UInt32[] ldata = new UInt32[lineWidth];

        public hDCache()
        {
          
            reset();
        }

        public void write(UInt32 address, UInt32 data)
        {
            tag = address >> lineWidthBits;
            valids[address & (lineWidth - 1)] = true;
            ldata[address & (lineWidth - 1)] = data;
        }

        public bool read(UInt32 address, out UInt32 data)
        {
            bool found = false;
            data = 0xfeadbabe;

            if ((tag == (address >> lineWidthBits)) && valids[address & (lineWidth - 1)] == true)
            {
                data = ldata[address & (lineWidth - 1)];
                found = true;
            }

            return found;
        }

        public void reset()
        {
            tag = 0;

            for(int i=0;i<lineWidth;i++)
            {
                valids[i] = false;
            }
        }

        /*const int lineWidthBits = 8;
        const uint lineWidth = (uint)(1 << lineWidthBits);
        
        const int lineCountBits = 1;
        const uint lineCount = (uint)(1 << lineCountBits);
        

        class cacheLine
        {
           public UInt32 tag;
           public bool[] valids = new bool[lineWidth];
           public UInt32[] data = new UInt32[lineWidth];
        }

        cacheLine[] m_cache = new cacheLine[lineCount];

        public hDCache()
        {
            for (int i = 0; i < lineCount; i++)
            {
                m_cache[i] = new cacheLine();
            }
            reset();
        }

        public void write(UInt32 address, UInt32 data)
        {
            // address
            // TTTTTTTTTTTYYYDDDDDDDD
          
            uint cachLine = (address>>lineWidthBits) & ((1<<lineCountBits)-1);
            uint tag = (address >> (lineWidthBits + lineCountBits));
            uint pos = address & ((1 << lineWidthBits) - 1);

            if (m_cache[cachLine].tag == tag) // tag found
            {
                m_cache[cachLine].valids[pos] = true;
                m_cache[cachLine].data[pos] = data;
            }
            else // replace
            {
                for (int j = 0; j < lineWidth; j++)
                {
                    m_cache[cachLine].valids[j] = false;
                }

                m_cache[cachLine].valids[pos] = true;
                m_cache[cachLine].data[pos] = data;
                m_cache[cachLine].tag = tag;
            }          
        }

        public bool read(UInt32 address,out UInt32 data)
        {
            bool found = false;
            data = 0;

            uint cachLine = (address>>lineWidthBits) & ((1<<lineCountBits)-1);
            uint tag = (address >> (lineWidthBits + lineCountBits));
            uint pos = address & ((1 << lineWidthBits) - 1);

            if (m_cache[cachLine].tag == tag && m_cache[cachLine].valids[pos] == true) // tag found & valid
            {
                data = m_cache[cachLine].data[pos];
                found = true;
            }

            return found;
        }

        public void reset()
        {
            for (int i = 0; i < lineCount; i++)
            {
                m_cache[i].tag = 0xffffffff;
                for (int j = 0; j < lineWidth; j++)
                {
                    m_cache[i].valids[j] = false;
                }
            }
        }*/
    }
}
