﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;
using xcore_tools.Data;
using xcore_tools.Common;

namespace xcore_tools
{
    public class PreprocessorMacro
    {
        static UInt64 m_loopCounter = 0;

        public PreprocessorMacro(String iname, String[] iargs, string itext)
        {
            name = iname;
            args = iargs;
            text = itext;
        }

        public string[] resolve(String[] iargs)
        {
            string dout = text;

            if (args != null)
            {
                if (iargs.Count() != args.Count())
                {
                    throw new Exception("Error at preprocessor macro resolving, argument count is not equal to definition at macro name '" + name + "'");
                }

                for (int i = 0; i < iargs.Count(); i++)
                {
                    string source = args[i];
                    string replace = iargs[i];
                    dout = dout.Replace(source, replace);
                }
            }

            // scan for special @ (loop renamer)

            dout = dout.Replace("@", "" + m_loopCounter);

            m_loopCounter++;

            return dout.Split('\n');
        }

        public string name;
        public string[] args { get; set; }
        public string text { get; set; }
    }
}
