library ieee;
use work.bus_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sdCtrl_crc16t is
		port 
		(
				-- global

				clk				: in std_logic;
				reset				: in std_logic;	

				--  
				
				dclr				: in std_logic;
				din				: in std_logic;
				din_en			: in std_logic;
				dout 				: out std_logic_vector(15 downto 0)

		);
end entity;

architecture rtl of sdCtrl_crc16t is

signal crc_data : std_logic_vector(15 downto 0) := (others =>'0');	

begin

	--
	
	dout <= crc_data;
	
	-- calc

	process(clk)
	begin
		if rising_edge(clk) then
			if reset = '1' or dclr = '1' then
				crc_data <= (others =>'0');
			else
				if din_en = '1' then
					crc_data(0) <= din xor crc_data(15); 
					crc_data(1)  <= crc_data(0); 
					crc_data(2)  <= crc_data(1); 
					crc_data(3)  <= crc_data(2); 
					crc_data(4)  <= crc_data(3); 
					crc_data(5)  <= din xor crc_data(4) xor crc_data(15); 
					crc_data(6)  <= crc_data(5); 
					crc_data(7)  <= crc_data(6); 
					crc_data(8)  <= crc_data(7); 
					crc_data(9)  <= crc_data(8); 
					crc_data(10) <= crc_data(9); 
					crc_data(11) <= crc_data(10); 
					crc_data(12) <= din xor crc_data(11) xor crc_data(15); 
					crc_data(13) <= crc_data(12); 
					crc_data(14) <= crc_data(13); 
					crc_data(15) <= crc_data(14); 
				end if;
			end if;
		end if;
	end process;

end rtl;
