library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity utility_ctrl_vga_rgb_line_cache is
		port 
		(
				-- 
				
				clk				: in std_logic;
				reset				: in std_logic;
				
	
				-- read 
							
				rdaddress		: in std_logic_vector (10 downto 0);
				q					: out std_logic_vector (23 downto 0);
						
				-- push
				
				setwaddress		: in std_logic;
				wdaddress		: in std_logic_vector (10 downto 0);
				
				pushin			: in std_logic;
				pushdata			: in std_logic_vector (31 downto 0);
				pushmode			: in std_logic_vector(1 downto 0);
				pushready		: out std_logic
				
		
		);
end entity;



architecture rtl of utility_ctrl_vga_rgb_line_cache is

	type x_t is array(0 to 2047) of std_logic_vector(7 downto 0);
	
	signal dr : x_t := ( x"FF",x"01",x"02",x"03",x"04",x"05",x"06",x"07",x"08",x"09",x"0A",x"0B",x"0C",x"0D",x"0E",x"0F",x"10",x"11",x"12",x"13",x"14",x"15",x"16",x"17",x"18",x"19",x"1A",x"1B",x"1C",x"1D",x"1E",x"1F",x"20",x"21",x"22",x"23",x"24",x"25",x"26",x"27",x"28",x"29",x"2A",x"2B",x"2C",x"2D",x"2E",x"2F",x"30",x"31",x"32",x"33",x"34",x"35",x"36",x"37",x"38",x"39",x"3A",x"3B",x"3C",x"3D",x"3E",x"3F",								x"40",x"41",x"42",x"43",x"44",x"45",x"46",x"47",x"48",x"49",x"4A",x"4B",x"4C",x"4D",x"4E",x"4F",x"50",x"51",x"52",x"53",x"54",x"55",x"56",x"57",x"58",x"59",x"5A",x"5B",x"5C",x"5D",x"5E",x"5F",x"60",x"61",x"62",x"63",x"64",x"65",x"66",x"67",x"68",x"69",x"6A",x"6B",x"6C",x"6D",x"6E",x"6F",x"70",x"71",x"72",x"73",x"74",x"75",x"76",x"77",x"78",x"79",x"7A",x"7B",x"7C",x"7D",x"7E",x"7F",								x"80",x"81",x"82",x"83",x"84",x"85",x"86",x"87",x"88",x"89",x"8A",x"8B",x"8C",x"8D",x"8E",x"8F",x"90",x"91",x"92",x"93",x"94",x"95",x"96",x"97",x"98",x"99",x"9A",x"9B",x"9C",x"9D",x"9E",x"9F",x"A0",x"A1",x"A2",x"A3",x"A4",x"A5",x"A6",x"A7",x"A8",x"A9",x"AA",x"AB",x"AC",x"AD",x"AE",x"AF",x"B0",x"B1",x"B2",x"B3",x"B4",x"B5",x"B6",x"B7",x"B8",x"B9",x"BA",x"BB",x"BC",x"BD",x"BE",x"BF",								x"C0",x"C1",x"C2",x"C3",x"C4",x"C5",x"C6",x"C7",x"C8",x"C9",x"CA",x"CB",x"CC",x"CD",x"CE",x"CF",x"D0",x"D1",x"D2",x"D3",x"D4",x"D5",x"D6",x"D7",x"D8",x"D9",x"DA",x"DB",x"DC",x"DD",x"DE",x"DF",x"E0",x"E1",x"E2",x"E3",x"E4",x"E5",x"E6",x"E7",x"E8",x"E9",x"EA",x"EB",x"EC",x"ED",x"EE",x"EF",x"F0",x"F1",x"F2",x"F3",x"F4",x"F5",x"F6",x"F7",x"F8",x"F9",x"FA",x"FB",x"FC",x"FD",x"FE",x"FF",								x"00",x"01",x"02",x"03",x"04",x"05",x"06",x"07",x"08",x"09",x"0A",x"0B",x"0C",x"0D",x"0E",x"0F",x"10",x"11",x"12",x"13",x"14",x"15",x"16",x"17",x"18",x"19",x"1A",x"1B",x"1C",x"1D",x"1E",x"1F",x"20",x"21",x"22",x"23",x"24",x"25",x"26",x"27",x"28",x"29",x"2A",x"2B",x"2C",x"2D",x"2E",x"2F",x"30",x"31",x"32",x"33",x"34",x"35",x"36",x"37",x"38",x"39",x"3A",x"3B",x"3C",x"3D",x"3E",x"3F",								x"40",x"41",x"42",x"43",x"44",x"45",x"46",x"47",x"48",x"49",x"4A",x"4B",x"4C",x"4D",x"4E",x"4F",x"50",x"51",x"52",x"53",x"54",x"55",x"56",x"57",x"58",x"59",x"5A",x"5B",x"5C",x"5D",x"5E",x"5F",x"60",x"61",x"62",x"63",x"64",x"65",x"66",x"67",x"68",x"69",x"6A",x"6B",x"6C",x"6D",x"6E",x"6F",x"70",x"71",x"72",x"73",x"74",x"75",x"76",x"77",x"78",x"79",x"7A",x"7B",x"7C",x"7D",x"7E",x"7F",								x"80",x"81",x"82",x"83",x"84",x"85",x"86",x"87",x"88",x"89",x"8A",x"8B",x"8C",x"8D",x"8E",x"8F",x"90",x"91",x"92",x"93",x"94",x"95",x"96",x"97",x"98",x"99",x"9A",x"9B",x"9C",x"9D",x"9E",x"9F",x"A0",x"A1",x"A2",x"A3",x"A4",x"A5",x"A6",x"A7",x"A8",x"A9",x"AA",x"AB",x"AC",x"AD",x"AE",x"AF",x"B0",x"B1",x"B2",x"B3",x"B4",x"B5",x"B6",x"B7",x"B8",x"B9",x"BA",x"BB",x"BC",x"BD",x"BE",x"BF",								x"C0",x"C1",x"C2",x"C3",x"C4",x"C5",x"C6",x"C7",x"C8",x"C9",x"CA",x"CB",x"CC",x"CD",x"CE",x"CF",x"D0",x"D1",x"D2",x"D3",x"D4",x"D5",x"D6",x"D7",x"D8",x"D9",x"DA",x"DB",x"DC",x"DD",x"DE",x"DF",x"E0",x"E1",x"E2",x"E3",x"E4",x"E5",x"E6",x"E7",x"E8",x"E9",x"EA",x"EB",x"EC",x"ED",x"EE",x"EF",x"F0",x"F1",x"F2",x"F3",x"F4",x"F5",x"F6",x"F7",x"F8",x"F9",x"FA",x"FB",x"FC",x"FD",x"FE",x"FF",								x"00",x"01",x"02",x"03",x"04",x"05",x"06",x"07",x"08",x"09",x"0A",x"0B",x"0C",x"0D",x"0E",x"0F",x"10",x"11",x"12",x"13",x"14",x"15",x"16",x"17",x"18",x"19",x"1A",x"1B",x"1C",x"1D",x"1E",x"1F",x"20",x"21",x"22",x"23",x"24",x"25",x"26",x"27",x"28",x"29",x"2A",x"2B",x"2C",x"2D",x"2E",x"2F",x"30",x"31",x"32",x"33",x"34",x"35",x"36",x"37",x"38",x"39",x"3A",x"3B",x"3C",x"3D",x"3E",x"3F",								x"40",x"41",x"42",x"43",x"44",x"45",x"46",x"47",x"48",x"49",x"4A",x"4B",x"4C",x"4D",x"4E",x"4F",x"50",x"51",x"52",x"53",x"54",x"55",x"56",x"57",x"58",x"59",x"5A",x"5B",x"5C",x"5D",x"5E",x"5F",x"60",x"61",x"62",x"63",x"64",x"65",x"66",x"67",x"68",x"69",x"6A",x"6B",x"6C",x"6D",x"6E",x"6F",x"70",x"71",x"72",x"73",x"74",x"75",x"76",x"77",x"78",x"79",x"7A",x"7B",x"7C",x"7D",x"7E",x"7F",								x"80",x"81",x"82",x"83",x"84",x"85",x"86",x"87",x"88",x"89",x"8A",x"8B",x"8C",x"8D",x"8E",x"8F",x"90",x"91",x"92",x"93",x"94",x"95",x"96",x"97",x"98",x"99",x"9A",x"9B",x"9C",x"9D",x"9E",x"9F",x"A0",x"A1",x"A2",x"A3",x"A4",x"A5",x"A6",x"A7",x"A8",x"A9",x"AA",x"AB",x"AC",x"AD",x"AE",x"AF",x"B0",x"B1",x"B2",x"B3",x"B4",x"B5",x"B6",x"B7",x"B8",x"B9",x"BA",x"BB",x"BC",x"BD",x"BE",x"BF",								x"C0",x"C1",x"C2",x"C3",x"C4",x"C5",x"C6",x"C7",x"C8",x"C9",x"CA",x"CB",x"CC",x"CD",x"CE",x"CF",x"D0",x"D1",x"D2",x"D3",x"D4",x"D5",x"D6",x"D7",x"D8",x"D9",x"DA",x"DB",x"DC",x"DD",x"DE",x"DF",x"E0",x"E1",x"E2",x"E3",x"E4",x"E5",x"E6",x"E7",x"E8",x"E9",x"EA",x"EB",x"EC",x"ED",x"EE",x"EF",x"F0",x"F1",x"F2",x"F3",x"F4",x"F5",x"F6",x"F7",x"F8",x"F9",x"FA",x"FB",x"FC",x"FD",x"FE",x"FF",								x"00",x"01",x"02",x"03",x"04",x"05",x"06",x"07",x"08",x"09",x"0A",x"0B",x"0C",x"0D",x"0E",x"0F",x"10",x"11",x"12",x"13",x"14",x"15",x"16",x"17",x"18",x"19",x"1A",x"1B",x"1C",x"1D",x"1E",x"1F",x"20",x"21",x"22",x"23",x"24",x"25",x"26",x"27",x"28",x"29",x"2A",x"2B",x"2C",x"2D",x"2E",x"2F",x"30",x"31",x"32",x"33",x"34",x"35",x"36",x"37",x"38",x"39",x"3A",x"3B",x"3C",x"3D",x"3E",x"3F",								x"40",x"41",x"42",x"43",x"44",x"45",x"46",x"47",x"48",x"49",x"4A",x"4B",x"4C",x"4D",x"4E",x"4F",x"50",x"51",x"52",x"53",x"54",x"55",x"56",x"57",x"58",x"59",x"5A",x"5B",x"5C",x"5D",x"5E",x"5F",x"60",x"61",x"62",x"63",x"64",x"65",x"66",x"67",x"68",x"69",x"6A",x"6B",x"6C",x"6D",x"6E",x"6F",x"70",x"71",x"72",x"73",x"74",x"75",x"76",x"77",x"78",x"79",x"7A",x"7B",x"7C",x"7D",x"7E",x"7F",								x"80",x"81",x"82",x"83",x"84",x"85",x"86",x"87",x"88",x"89",x"8A",x"8B",x"8C",x"8D",x"8E",x"8F",x"90",x"91",x"92",x"93",x"94",x"95",x"96",x"97",x"98",x"99",x"9A",x"9B",x"9C",x"9D",x"9E",x"9F",x"A0",x"A1",x"A2",x"A3",x"A4",x"A5",x"A6",x"A7",x"A8",x"A9",x"AA",x"AB",x"AC",x"AD",x"AE",x"AF",x"B0",x"B1",x"B2",x"B3",x"B4",x"B5",x"B6",x"B7",x"B8",x"B9",x"BA",x"BB",x"BC",x"BD",x"BE",x"BF",								x"C0",x"C1",x"C2",x"C3",x"C4",x"C5",x"C6",x"C7",x"C8",x"C9",x"CA",x"CB",x"CC",x"CD",x"CE",x"CF",x"D0",x"D1",x"D2",x"D3",x"D4",x"D5",x"D6",x"D7",x"D8",x"D9",x"DA",x"DB",x"DC",x"DD",x"DE",x"DF",x"E0",x"E1",x"E2",x"E3",x"E4",x"E5",x"E6",x"E7",x"E8",x"E9",x"EA",x"EB",x"EC",x"ED",x"EE",x"EF",x"F0",x"F1",x"F2",x"F3",x"F4",x"F5",x"F6",x"F7",x"F8",x"F9",x"FA",x"FB",x"FC",x"FD",x"FE",x"FF",								x"00",x"01",x"02",x"03",x"04",x"05",x"06",x"07",x"08",x"09",x"0A",x"0B",x"0C",x"0D",x"0E",x"0F",x"10",x"11",x"12",x"13",x"14",x"15",x"16",x"17",x"18",x"19",x"1A",x"1B",x"1C",x"1D",x"1E",x"1F",x"20",x"21",x"22",x"23",x"24",x"25",x"26",x"27",x"28",x"29",x"2A",x"2B",x"2C",x"2D",x"2E",x"2F",x"30",x"31",x"32",x"33",x"34",x"35",x"36",x"37",x"38",x"39",x"3A",x"3B",x"3C",x"3D",x"3E",x"3F",								x"40",x"41",x"42",x"43",x"44",x"45",x"46",x"47",x"48",x"49",x"4A",x"4B",x"4C",x"4D",x"4E",x"4F",x"50",x"51",x"52",x"53",x"54",x"55",x"56",x"57",x"58",x"59",x"5A",x"5B",x"5C",x"5D",x"5E",x"5F",x"60",x"61",x"62",x"63",x"64",x"65",x"66",x"67",x"68",x"69",x"6A",x"6B",x"6C",x"6D",x"6E",x"6F",x"70",x"71",x"72",x"73",x"74",x"75",x"76",x"77",x"78",x"79",x"7A",x"7B",x"7C",x"7D",x"7E",x"7F",								x"80",x"81",x"82",x"83",x"84",x"85",x"86",x"87",x"88",x"89",x"8A",x"8B",x"8C",x"8D",x"8E",x"8F",x"90",x"91",x"92",x"93",x"94",x"95",x"96",x"97",x"98",x"99",x"9A",x"9B",x"9C",x"9D",x"9E",x"9F",x"A0",x"A1",x"A2",x"A3",x"A4",x"A5",x"A6",x"A7",x"A8",x"A9",x"AA",x"AB",x"AC",x"AD",x"AE",x"AF",x"B0",x"B1",x"B2",x"B3",x"B4",x"B5",x"B6",x"B7",x"B8",x"B9",x"BA",x"BB",x"BC",x"BD",x"BE",x"BF",								x"C0",x"C1",x"C2",x"C3",x"C4",x"C5",x"C6",x"C7",x"C8",x"C9",x"CA",x"CB",x"CC",x"CD",x"CE",x"CF",x"D0",x"D1",x"D2",x"D3",x"D4",x"D5",x"D6",x"D7",x"D8",x"D9",x"DA",x"DB",x"DC",x"DD",x"DE",x"DF",x"E0",x"E1",x"E2",x"E3",x"E4",x"E5",x"E6",x"E7",x"E8",x"E9",x"EA",x"EB",x"EC",x"ED",x"EE",x"EF",x"F0",x"F1",x"F2",x"F3",x"F4",x"F5",x"F6",x"F7",x"F8",x"F9",x"FA",x"FB",x"FC",x"FD",x"FE",x"FF",								x"00",x"01",x"02",x"03",x"04",x"05",x"06",x"07",x"08",x"09",x"0A",x"0B",x"0C",x"0D",x"0E",x"0F",x"10",x"11",x"12",x"13",x"14",x"15",x"16",x"17",x"18",x"19",x"1A",x"1B",x"1C",x"1D",x"1E",x"1F",x"20",x"21",x"22",x"23",x"24",x"25",x"26",x"27",x"28",x"29",x"2A",x"2B",x"2C",x"2D",x"2E",x"2F",x"30",x"31",x"32",x"33",x"34",x"35",x"36",x"37",x"38",x"39",x"3A",x"3B",x"3C",x"3D",x"3E",x"3F",								x"40",x"41",x"42",x"43",x"44",x"45",x"46",x"47",x"48",x"49",x"4A",x"4B",x"4C",x"4D",x"4E",x"4F",x"50",x"51",x"52",x"53",x"54",x"55",x"56",x"57",x"58",x"59",x"5A",x"5B",x"5C",x"5D",x"5E",x"5F",x"60",x"61",x"62",x"63",x"64",x"65",x"66",x"67",x"68",x"69",x"6A",x"6B",x"6C",x"6D",x"6E",x"6F",x"70",x"71",x"72",x"73",x"74",x"75",x"76",x"77",x"78",x"79",x"7A",x"7B",x"7C",x"7D",x"7E",x"7F",								x"80",x"81",x"82",x"83",x"84",x"85",x"86",x"87",x"88",x"89",x"8A",x"8B",x"8C",x"8D",x"8E",x"8F",x"90",x"91",x"92",x"93",x"94",x"95",x"96",x"97",x"98",x"99",x"9A",x"9B",x"9C",x"9D",x"9E",x"FF",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00");																	
	signal dg : x_t := (	x"FF",x"00",x"00",x"00",x"01",x"01",x"01",x"01",x"02",x"02",x"02",x"02",x"03",x"03",x"03",x"03",x"04",x"04",x"04",x"04",x"05",x"05",x"05",x"05",x"06",x"06",x"06",x"06",x"07",x"07",x"07",x"07",x"08",x"08",x"08",x"08",x"09",x"09",x"09",x"09",x"0A",x"0A",x"0A",x"0A",x"0B",x"0B",x"0B",x"0B",x"0C",x"0C",x"0C",x"0C",x"0D",x"0D",x"0D",x"0D",x"0E",x"0E",x"0E",x"0E",x"0F",x"0F",x"0F",x"0F",								x"10",x"10",x"10",x"10",x"11",x"11",x"11",x"11",x"12",x"12",x"12",x"12",x"13",x"13",x"13",x"13",x"14",x"14",x"14",x"14",x"15",x"15",x"15",x"15",x"16",x"16",x"16",x"16",x"17",x"17",x"17",x"17",x"18",x"18",x"18",x"18",x"19",x"19",x"19",x"19",x"1A",x"1A",x"1A",x"1A",x"1B",x"1B",x"1B",x"1B",x"1C",x"1C",x"1C",x"1C",x"1D",x"1D",x"1D",x"1D",x"1E",x"1E",x"1E",x"1E",x"1F",x"1F",x"1F",x"1F",								x"20",x"20",x"20",x"20",x"21",x"21",x"21",x"21",x"22",x"22",x"22",x"22",x"23",x"23",x"23",x"23",x"24",x"24",x"24",x"24",x"25",x"25",x"25",x"25",x"26",x"26",x"26",x"26",x"27",x"27",x"27",x"27",x"28",x"28",x"28",x"28",x"29",x"29",x"29",x"29",x"2A",x"2A",x"2A",x"2A",x"2B",x"2B",x"2B",x"2B",x"2C",x"2C",x"2C",x"2C",x"2D",x"2D",x"2D",x"2D",x"2E",x"2E",x"2E",x"2E",x"2F",x"2F",x"2F",x"2F",								x"30",x"30",x"30",x"30",x"31",x"31",x"31",x"31",x"32",x"32",x"32",x"32",x"33",x"33",x"33",x"33",x"34",x"34",x"34",x"34",x"35",x"35",x"35",x"35",x"36",x"36",x"36",x"36",x"37",x"37",x"37",x"37",x"38",x"38",x"38",x"38",x"39",x"39",x"39",x"39",x"3A",x"3A",x"3A",x"3A",x"3B",x"3B",x"3B",x"3B",x"3C",x"3C",x"3C",x"3C",x"3D",x"3D",x"3D",x"3D",x"3E",x"3E",x"3E",x"3E",x"3F",x"3F",x"3F",x"3F",								x"40",x"40",x"40",x"40",x"41",x"41",x"41",x"41",x"42",x"42",x"42",x"42",x"43",x"43",x"43",x"43",x"44",x"44",x"44",x"44",x"45",x"45",x"45",x"45",x"46",x"46",x"46",x"46",x"47",x"47",x"47",x"47",x"48",x"48",x"48",x"48",x"49",x"49",x"49",x"49",x"4A",x"4A",x"4A",x"4A",x"4B",x"4B",x"4B",x"4B",x"4C",x"4C",x"4C",x"4C",x"4D",x"4D",x"4D",x"4D",x"4E",x"4E",x"4E",x"4E",x"4F",x"4F",x"4F",x"4F",								x"50",x"50",x"50",x"50",x"51",x"51",x"51",x"51",x"52",x"52",x"52",x"52",x"53",x"53",x"53",x"53",x"54",x"54",x"54",x"54",x"55",x"55",x"55",x"55",x"56",x"56",x"56",x"56",x"57",x"57",x"57",x"57",x"58",x"58",x"58",x"58",x"59",x"59",x"59",x"59",x"5A",x"5A",x"5A",x"5A",x"5B",x"5B",x"5B",x"5B",x"5C",x"5C",x"5C",x"5C",x"5D",x"5D",x"5D",x"5D",x"5E",x"5E",x"5E",x"5E",x"5F",x"5F",x"5F",x"5F",								x"60",x"60",x"60",x"60",x"61",x"61",x"61",x"61",x"62",x"62",x"62",x"62",x"63",x"63",x"63",x"63",x"64",x"64",x"64",x"64",x"65",x"65",x"65",x"65",x"66",x"66",x"66",x"66",x"67",x"67",x"67",x"67",x"68",x"68",x"68",x"68",x"69",x"69",x"69",x"69",x"6A",x"6A",x"6A",x"6A",x"6B",x"6B",x"6B",x"6B",x"6C",x"6C",x"6C",x"6C",x"6D",x"6D",x"6D",x"6D",x"6E",x"6E",x"6E",x"6E",x"6F",x"6F",x"6F",x"6F",								x"70",x"70",x"70",x"70",x"71",x"71",x"71",x"71",x"72",x"72",x"72",x"72",x"73",x"73",x"73",x"73",x"74",x"74",x"74",x"74",x"75",x"75",x"75",x"75",x"76",x"76",x"76",x"76",x"77",x"77",x"77",x"77",x"78",x"78",x"78",x"78",x"79",x"79",x"79",x"79",x"7A",x"7A",x"7A",x"7A",x"7B",x"7B",x"7B",x"7B",x"7C",x"7C",x"7C",x"7C",x"7D",x"7D",x"7D",x"7D",x"7E",x"7E",x"7E",x"7E",x"7F",x"7F",x"7F",x"7F",								x"80",x"80",x"80",x"80",x"81",x"81",x"81",x"81",x"82",x"82",x"82",x"82",x"83",x"83",x"83",x"83",x"84",x"84",x"84",x"84",x"85",x"85",x"85",x"85",x"86",x"86",x"86",x"86",x"87",x"87",x"87",x"87",x"88",x"88",x"88",x"88",x"89",x"89",x"89",x"89",x"8A",x"8A",x"8A",x"8A",x"8B",x"8B",x"8B",x"8B",x"8C",x"8C",x"8C",x"8C",x"8D",x"8D",x"8D",x"8D",x"8E",x"8E",x"8E",x"8E",x"8F",x"8F",x"8F",x"8F",								x"90",x"90",x"90",x"90",x"91",x"91",x"91",x"91",x"92",x"92",x"92",x"92",x"93",x"93",x"93",x"93",x"94",x"94",x"94",x"94",x"95",x"95",x"95",x"95",x"96",x"96",x"96",x"96",x"97",x"97",x"97",x"97",x"98",x"98",x"98",x"98",x"99",x"99",x"99",x"99",x"9A",x"9A",x"9A",x"9A",x"9B",x"9B",x"9B",x"9B",x"9C",x"9C",x"9C",x"9C",x"9D",x"9D",x"9D",x"9D",x"9E",x"9E",x"9E",x"9E",x"9F",x"9F",x"9F",x"9F",								x"A0",x"A0",x"A0",x"A0",x"A1",x"A1",x"A1",x"A1",x"A2",x"A2",x"A2",x"A2",x"A3",x"A3",x"A3",x"A3",x"A4",x"A4",x"A4",x"A4",x"A5",x"A5",x"A5",x"A5",x"A6",x"A6",x"A6",x"A6",x"A7",x"A7",x"A7",x"A7",x"A8",x"A8",x"A8",x"A8",x"A9",x"A9",x"A9",x"A9",x"AA",x"AA",x"AA",x"AA",x"AB",x"AB",x"AB",x"AB",x"AC",x"AC",x"AC",x"AC",x"AD",x"AD",x"AD",x"AD",x"AE",x"AE",x"AE",x"AE",x"AF",x"AF",x"AF",x"AF",								x"B0",x"B0",x"B0",x"B0",x"B1",x"B1",x"B1",x"B1",x"B2",x"B2",x"B2",x"B2",x"B3",x"B3",x"B3",x"B3",x"B4",x"B4",x"B4",x"B4",x"B5",x"B5",x"B5",x"B5",x"B6",x"B6",x"B6",x"B6",x"B7",x"B7",x"B7",x"B7",x"B8",x"B8",x"B8",x"B8",x"B9",x"B9",x"B9",x"B9",x"BA",x"BA",x"BA",x"BA",x"BB",x"BB",x"BB",x"BB",x"BC",x"BC",x"BC",x"BC",x"BD",x"BD",x"BD",x"BD",x"BE",x"BE",x"BE",x"BE",x"BF",x"BF",x"BF",x"BF",								x"C0",x"C0",x"C0",x"C0",x"C1",x"C1",x"C1",x"C1",x"C2",x"C2",x"C2",x"C2",x"C3",x"C3",x"C3",x"C3",x"C4",x"C4",x"C4",x"C4",x"C5",x"C5",x"C5",x"C5",x"C6",x"C6",x"C6",x"C6",x"C7",x"C7",x"C7",x"C7",x"C8",x"C8",x"C8",x"C8",x"C9",x"C9",x"C9",x"C9",x"CA",x"CA",x"CA",x"CA",x"CB",x"CB",x"CB",x"CB",x"CC",x"CC",x"CC",x"CC",x"CD",x"CD",x"CD",x"CD",x"CE",x"CE",x"CE",x"CE",x"CF",x"CF",x"CF",x"CF",								x"D0",x"D0",x"D0",x"D0",x"D1",x"D1",x"D1",x"D1",x"D2",x"D2",x"D2",x"D2",x"D3",x"D3",x"D3",x"D3",x"D4",x"D4",x"D4",x"D4",x"D5",x"D5",x"D5",x"D5",x"D6",x"D6",x"D6",x"D6",x"D7",x"D7",x"D7",x"D7",x"D8",x"D8",x"D8",x"D8",x"D9",x"D9",x"D9",x"D9",x"DA",x"DA",x"DA",x"DA",x"DB",x"DB",x"DB",x"DB",x"DC",x"DC",x"DC",x"DC",x"DD",x"DD",x"DD",x"DD",x"DE",x"DE",x"DE",x"DE",x"DF",x"DF",x"DF",x"DF",								x"E0",x"E0",x"E0",x"E0",x"E1",x"E1",x"E1",x"E1",x"E2",x"E2",x"E2",x"E2",x"E3",x"E3",x"E3",x"E3",x"E4",x"E4",x"E4",x"E4",x"E5",x"E5",x"E5",x"E5",x"E6",x"E6",x"E6",x"E6",x"E7",x"E7",x"E7",x"E7",x"E8",x"E8",x"E8",x"E8",x"E9",x"E9",x"E9",x"E9",x"EA",x"EA",x"EA",x"EA",x"EB",x"EB",x"EB",x"EB",x"EC",x"EC",x"EC",x"EC",x"ED",x"ED",x"ED",x"ED",x"EE",x"EE",x"EE",x"EE",x"EF",x"EF",x"EF",x"EF",								x"F0",x"F0",x"F0",x"F0",x"F1",x"F1",x"F1",x"F1",x"F2",x"F2",x"F2",x"F2",x"F3",x"F3",x"F3",x"F3",x"F4",x"F4",x"F4",x"F4",x"F5",x"F5",x"F5",x"F5",x"F6",x"F6",x"F6",x"F6",x"F7",x"F7",x"F7",x"F7",x"F8",x"F8",x"F8",x"F8",x"F9",x"F9",x"F9",x"F9",x"FA",x"FA",x"FA",x"FA",x"FB",x"FB",x"FB",x"FB",x"FC",x"FC",x"FC",x"FC",x"FD",x"FD",x"FD",x"FD",x"FE",x"FE",x"FE",x"FE",x"FF",x"FF",x"FF",x"FF",								x"00",x"00",x"00",x"00",x"01",x"01",x"01",x"01",x"02",x"02",x"02",x"02",x"03",x"03",x"03",x"03",x"04",x"04",x"04",x"04",x"05",x"05",x"05",x"05",x"06",x"06",x"06",x"06",x"07",x"07",x"07",x"07",x"08",x"08",x"08",x"08",x"09",x"09",x"09",x"09",x"0A",x"0A",x"0A",x"0A",x"0B",x"0B",x"0B",x"0B",x"0C",x"0C",x"0C",x"0C",x"0D",x"0D",x"0D",x"0D",x"0E",x"0E",x"0E",x"0E",x"0F",x"0F",x"0F",x"0F",								x"10",x"10",x"10",x"10",x"11",x"11",x"11",x"11",x"12",x"12",x"12",x"12",x"13",x"13",x"13",x"13",x"14",x"14",x"14",x"14",x"15",x"15",x"15",x"15",x"16",x"16",x"16",x"16",x"17",x"17",x"17",x"17",x"18",x"18",x"18",x"18",x"19",x"19",x"19",x"19",x"1A",x"1A",x"1A",x"1A",x"1B",x"1B",x"1B",x"1B",x"1C",x"1C",x"1C",x"1C",x"1D",x"1D",x"1D",x"1D",x"1E",x"1E",x"1E",x"1E",x"1F",x"1F",x"1F",x"1F",								x"20",x"20",x"20",x"20",x"21",x"21",x"21",x"21",x"22",x"22",x"22",x"22",x"23",x"23",x"23",x"23",x"24",x"24",x"24",x"24",x"25",x"25",x"25",x"25",x"26",x"26",x"26",x"26",x"27",x"27",x"27",x"27",x"28",x"28",x"28",x"28",x"29",x"29",x"29",x"29",x"2A",x"2A",x"2A",x"2A",x"2B",x"2B",x"2B",x"2B",x"2C",x"2C",x"2C",x"2C",x"2D",x"2D",x"2D",x"2D",x"2E",x"2E",x"2E",x"2E",x"2F",x"2F",x"2F",x"2F",								x"30",x"30",x"30",x"30",x"31",x"31",x"31",x"31",x"32",x"32",x"32",x"32",x"33",x"33",x"33",x"33",x"34",x"34",x"34",x"34",x"35",x"35",x"35",x"35",x"36",x"36",x"36",x"36",x"37",x"37",x"37",x"37",x"38",x"38",x"38",x"38",x"39",x"39",x"39",x"39",x"3A",x"3A",x"3A",x"3A",x"3B",x"3B",x"3B",x"3B",x"3C",x"3C",x"3C",x"3C",x"3D",x"3D",x"3D",x"3D",x"3E",x"3E",x"3E",x"3E",x"3F",x"3F",x"3F",x"3F",								x"40",x"40",x"40",x"40",x"41",x"41",x"41",x"41",x"42",x"42",x"42",x"42",x"43",x"43",x"43",x"43",x"44",x"44",x"44",x"44",x"45",x"45",x"45",x"45",x"46",x"46",x"46",x"46",x"47",x"47",x"47",x"47",x"48",x"48",x"48",x"48",x"49",x"49",x"49",x"49",x"4A",x"4A",x"4A",x"4A",x"4B",x"4B",x"4B",x"4B",x"4C",x"4C",x"4C",x"4C",x"4D",x"4D",x"4D",x"4D",x"4E",x"4E",x"4E",x"4E",x"4F",x"4F",x"4F",x"4F",								x"50",x"50",x"50",x"50",x"51",x"51",x"51",x"51",x"52",x"52",x"52",x"52",x"53",x"53",x"53",x"53",x"54",x"54",x"54",x"54",x"55",x"55",x"55",x"55",x"56",x"56",x"56",x"56",x"57",x"57",x"57",x"57",x"58",x"58",x"58",x"58",x"59",x"59",x"59",x"59",x"5A",x"5A",x"5A",x"5A",x"5B",x"5B",x"5B",x"5B",x"5C",x"5C",x"5C",x"5C",x"5D",x"5D",x"5D",x"5D",x"5E",x"5E",x"5E",x"5E",x"5F",x"5F",x"5F",x"5F",								x"60",x"60",x"60",x"60",x"61",x"61",x"61",x"61",x"62",x"62",x"62",x"62",x"63",x"63",x"63",x"63",x"64",x"64",x"64",x"64",x"65",x"65",x"65",x"65",x"66",x"66",x"66",x"66",x"67",x"67",x"67",x"FF",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00");																	
	signal db : x_t := (	x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"01",x"01",x"01",x"01",x"01",x"01",x"01",x"01",x"02",x"02",x"02",x"02",x"02",x"02",x"02",x"02",x"03",x"03",x"03",x"03",x"03",x"03",x"03",x"03",x"04",x"04",x"04",x"04",x"04",x"04",x"04",x"04",x"05",x"05",x"05",x"05",x"05",x"05",x"05",x"05",x"06",x"06",x"06",x"06",x"06",x"06",x"06",x"06",x"07",x"07",x"07",x"07",x"07",x"07",x"07",x"07",								x"08",x"08",x"08",x"08",x"08",x"08",x"08",x"08",x"09",x"09",x"09",x"09",x"09",x"09",x"09",x"09",x"0A",x"0A",x"0A",x"0A",x"0A",x"0A",x"0A",x"0A",x"0B",x"0B",x"0B",x"0B",x"0B",x"0B",x"0B",x"0B",x"0C",x"0C",x"0C",x"0C",x"0C",x"0C",x"0C",x"0C",x"0D",x"0D",x"0D",x"0D",x"0D",x"0D",x"0D",x"0D",x"0E",x"0E",x"0E",x"0E",x"0E",x"0E",x"0E",x"0E",x"0F",x"0F",x"0F",x"0F",x"0F",x"0F",x"0F",x"0F",								x"10",x"10",x"10",x"10",x"10",x"10",x"10",x"10",x"11",x"11",x"11",x"11",x"11",x"11",x"11",x"11",x"12",x"12",x"12",x"12",x"12",x"12",x"12",x"12",x"13",x"13",x"13",x"13",x"13",x"13",x"13",x"13",x"14",x"14",x"14",x"14",x"14",x"14",x"14",x"14",x"15",x"15",x"15",x"15",x"15",x"15",x"15",x"15",x"16",x"16",x"16",x"16",x"16",x"16",x"16",x"16",x"17",x"17",x"17",x"17",x"17",x"17",x"17",x"17",								x"18",x"18",x"18",x"18",x"18",x"18",x"18",x"18",x"19",x"19",x"19",x"19",x"19",x"19",x"19",x"19",x"1A",x"1A",x"1A",x"1A",x"1A",x"1A",x"1A",x"1A",x"1B",x"1B",x"1B",x"1B",x"1B",x"1B",x"1B",x"1B",x"1C",x"1C",x"1C",x"1C",x"1C",x"1C",x"1C",x"1C",x"1D",x"1D",x"1D",x"1D",x"1D",x"1D",x"1D",x"1D",x"1E",x"1E",x"1E",x"1E",x"1E",x"1E",x"1E",x"1E",x"1F",x"1F",x"1F",x"1F",x"1F",x"1F",x"1F",x"1F",								x"20",x"20",x"20",x"20",x"20",x"20",x"20",x"20",x"21",x"21",x"21",x"21",x"21",x"21",x"21",x"21",x"22",x"22",x"22",x"22",x"22",x"22",x"22",x"22",x"23",x"23",x"23",x"23",x"23",x"23",x"23",x"23",x"24",x"24",x"24",x"24",x"24",x"24",x"24",x"24",x"25",x"25",x"25",x"25",x"25",x"25",x"25",x"25",x"26",x"26",x"26",x"26",x"26",x"26",x"26",x"26",x"27",x"27",x"27",x"27",x"27",x"27",x"27",x"27",								x"28",x"28",x"28",x"28",x"28",x"28",x"28",x"28",x"29",x"29",x"29",x"29",x"29",x"29",x"29",x"29",x"2A",x"2A",x"2A",x"2A",x"2A",x"2A",x"2A",x"2A",x"2B",x"2B",x"2B",x"2B",x"2B",x"2B",x"2B",x"2B",x"2C",x"2C",x"2C",x"2C",x"2C",x"2C",x"2C",x"2C",x"2D",x"2D",x"2D",x"2D",x"2D",x"2D",x"2D",x"2D",x"2E",x"2E",x"2E",x"2E",x"2E",x"2E",x"2E",x"2E",x"2F",x"2F",x"2F",x"2F",x"2F",x"2F",x"2F",x"2F",								x"30",x"30",x"30",x"30",x"30",x"30",x"30",x"30",x"31",x"31",x"31",x"31",x"31",x"31",x"31",x"31",x"32",x"32",x"32",x"32",x"32",x"32",x"32",x"32",x"33",x"33",x"33",x"33",x"33",x"33",x"33",x"33",x"34",x"34",x"34",x"34",x"34",x"34",x"34",x"34",x"35",x"35",x"35",x"35",x"35",x"35",x"35",x"35",x"36",x"36",x"36",x"36",x"36",x"36",x"36",x"36",x"37",x"37",x"37",x"37",x"37",x"37",x"37",x"37",								x"38",x"38",x"38",x"38",x"38",x"38",x"38",x"38",x"39",x"39",x"39",x"39",x"39",x"39",x"39",x"39",x"3A",x"3A",x"3A",x"3A",x"3A",x"3A",x"3A",x"3A",x"3B",x"3B",x"3B",x"3B",x"3B",x"3B",x"3B",x"3B",x"3C",x"3C",x"3C",x"3C",x"3C",x"3C",x"3C",x"3C",x"3D",x"3D",x"3D",x"3D",x"3D",x"3D",x"3D",x"3D",x"3E",x"3E",x"3E",x"3E",x"3E",x"3E",x"3E",x"3E",x"3F",x"3F",x"3F",x"3F",x"3F",x"3F",x"3F",x"3F",								x"40",x"40",x"40",x"40",x"40",x"40",x"40",x"40",x"41",x"41",x"41",x"41",x"41",x"41",x"41",x"41",x"42",x"42",x"42",x"42",x"42",x"42",x"42",x"42",x"43",x"43",x"43",x"43",x"43",x"43",x"43",x"43",x"44",x"44",x"44",x"44",x"44",x"44",x"44",x"44",x"45",x"45",x"45",x"45",x"45",x"45",x"45",x"45",x"46",x"46",x"46",x"46",x"46",x"46",x"46",x"46",x"47",x"47",x"47",x"47",x"47",x"47",x"47",x"47",								x"48",x"48",x"48",x"48",x"48",x"48",x"48",x"48",x"49",x"49",x"49",x"49",x"49",x"49",x"49",x"49",x"4A",x"4A",x"4A",x"4A",x"4A",x"4A",x"4A",x"4A",x"4B",x"4B",x"4B",x"4B",x"4B",x"4B",x"4B",x"4B",x"4C",x"4C",x"4C",x"4C",x"4C",x"4C",x"4C",x"4C",x"4D",x"4D",x"4D",x"4D",x"4D",x"4D",x"4D",x"4D",x"4E",x"4E",x"4E",x"4E",x"4E",x"4E",x"4E",x"4E",x"4F",x"4F",x"4F",x"4F",x"4F",x"4F",x"4F",x"4F",								x"50",x"50",x"50",x"50",x"50",x"50",x"50",x"50",x"51",x"51",x"51",x"51",x"51",x"51",x"51",x"51",x"52",x"52",x"52",x"52",x"52",x"52",x"52",x"52",x"53",x"53",x"53",x"53",x"53",x"53",x"53",x"53",x"54",x"54",x"54",x"54",x"54",x"54",x"54",x"54",x"55",x"55",x"55",x"55",x"55",x"55",x"55",x"55",x"56",x"56",x"56",x"56",x"56",x"56",x"56",x"56",x"57",x"57",x"57",x"57",x"57",x"57",x"57",x"57",								x"58",x"58",x"58",x"58",x"58",x"58",x"58",x"58",x"59",x"59",x"59",x"59",x"59",x"59",x"59",x"59",x"5A",x"5A",x"5A",x"5A",x"5A",x"5A",x"5A",x"5A",x"5B",x"5B",x"5B",x"5B",x"5B",x"5B",x"5B",x"5B",x"5C",x"5C",x"5C",x"5C",x"5C",x"5C",x"5C",x"5C",x"5D",x"5D",x"5D",x"5D",x"5D",x"5D",x"5D",x"5D",x"5E",x"5E",x"5E",x"5E",x"5E",x"5E",x"5E",x"5E",x"5F",x"5F",x"5F",x"5F",x"5F",x"5F",x"5F",x"5F",								x"60",x"60",x"60",x"60",x"60",x"60",x"60",x"60",x"61",x"61",x"61",x"61",x"61",x"61",x"61",x"61",x"62",x"62",x"62",x"62",x"62",x"62",x"62",x"62",x"63",x"63",x"63",x"63",x"63",x"63",x"63",x"63",x"64",x"64",x"64",x"64",x"64",x"64",x"64",x"64",x"65",x"65",x"65",x"65",x"65",x"65",x"65",x"65",x"66",x"66",x"66",x"66",x"66",x"66",x"66",x"66",x"67",x"67",x"67",x"67",x"67",x"67",x"67",x"67",								x"68",x"68",x"68",x"68",x"68",x"68",x"68",x"68",x"69",x"69",x"69",x"69",x"69",x"69",x"69",x"69",x"6A",x"6A",x"6A",x"6A",x"6A",x"6A",x"6A",x"6A",x"6B",x"6B",x"6B",x"6B",x"6B",x"6B",x"6B",x"6B",x"6C",x"6C",x"6C",x"6C",x"6C",x"6C",x"6C",x"6C",x"6D",x"6D",x"6D",x"6D",x"6D",x"6D",x"6D",x"6D",x"6E",x"6E",x"6E",x"6E",x"6E",x"6E",x"6E",x"6E",x"6F",x"6F",x"6F",x"6F",x"6F",x"6F",x"6F",x"6F",								x"70",x"70",x"70",x"70",x"70",x"70",x"70",x"70",x"71",x"71",x"71",x"71",x"71",x"71",x"71",x"71",x"72",x"72",x"72",x"72",x"72",x"72",x"72",x"72",x"73",x"73",x"73",x"73",x"73",x"73",x"73",x"73",x"74",x"74",x"74",x"74",x"74",x"74",x"74",x"74",x"75",x"75",x"75",x"75",x"75",x"75",x"75",x"75",x"76",x"76",x"76",x"76",x"76",x"76",x"76",x"76",x"77",x"77",x"77",x"77",x"77",x"77",x"77",x"77",								x"78",x"78",x"78",x"78",x"78",x"78",x"78",x"78",x"79",x"79",x"79",x"79",x"79",x"79",x"79",x"79",x"7A",x"7A",x"7A",x"7A",x"7A",x"7A",x"7A",x"7A",x"7B",x"7B",x"7B",x"7B",x"7B",x"7B",x"7B",x"7B",x"7C",x"7C",x"7C",x"7C",x"7C",x"7C",x"7C",x"7C",x"7D",x"7D",x"7D",x"7D",x"7D",x"7D",x"7D",x"7D",x"7E",x"7E",x"7E",x"7E",x"7E",x"7E",x"7E",x"7E",x"7F",x"7F",x"7F",x"7F",x"7F",x"7F",x"7F",x"7F",								x"80",x"80",x"80",x"80",x"80",x"80",x"80",x"80",x"81",x"81",x"81",x"81",x"81",x"81",x"81",x"81",x"82",x"82",x"82",x"82",x"82",x"82",x"82",x"82",x"83",x"83",x"83",x"83",x"83",x"83",x"83",x"83",x"84",x"84",x"84",x"84",x"84",x"84",x"84",x"84",x"85",x"85",x"85",x"85",x"85",x"85",x"85",x"85",x"86",x"86",x"86",x"86",x"86",x"86",x"86",x"86",x"87",x"87",x"87",x"87",x"87",x"87",x"87",x"87",								x"88",x"88",x"88",x"88",x"88",x"88",x"88",x"88",x"89",x"89",x"89",x"89",x"89",x"89",x"89",x"89",x"8A",x"8A",x"8A",x"8A",x"8A",x"8A",x"8A",x"8A",x"8B",x"8B",x"8B",x"8B",x"8B",x"8B",x"8B",x"8B",x"8C",x"8C",x"8C",x"8C",x"8C",x"8C",x"8C",x"8C",x"8D",x"8D",x"8D",x"8D",x"8D",x"8D",x"8D",x"8D",x"8E",x"8E",x"8E",x"8E",x"8E",x"8E",x"8E",x"8E",x"8F",x"8F",x"8F",x"8F",x"8F",x"8F",x"8F",x"8F",								x"90",x"90",x"90",x"90",x"90",x"90",x"90",x"90",x"91",x"91",x"91",x"91",x"91",x"91",x"91",x"91",x"92",x"92",x"92",x"92",x"92",x"92",x"92",x"92",x"93",x"93",x"93",x"93",x"93",x"93",x"93",x"93",x"94",x"94",x"94",x"94",x"94",x"94",x"94",x"94",x"95",x"95",x"95",x"95",x"95",x"95",x"95",x"95",x"96",x"96",x"96",x"96",x"96",x"96",x"96",x"96",x"97",x"97",x"97",x"97",x"97",x"97",x"97",x"97",								x"98",x"98",x"98",x"98",x"98",x"98",x"98",x"98",x"99",x"99",x"99",x"99",x"99",x"99",x"99",x"99",x"9A",x"9A",x"9A",x"9A",x"9A",x"9A",x"9A",x"9A",x"9B",x"9B",x"9B",x"9B",x"9B",x"9B",x"9B",x"9B",x"9C",x"9C",x"9C",x"9C",x"9C",x"9C",x"9C",x"9C",x"9D",x"9D",x"9D",x"9D",x"9D",x"9D",x"9D",x"9D",x"9E",x"9E",x"9E",x"9E",x"9E",x"9E",x"9E",x"9E",x"9F",x"9F",x"9F",x"9F",x"9F",x"9F",x"9F",x"9F",								x"A0",x"A0",x"A0",x"A0",x"A0",x"A0",x"A0",x"A0",x"A1",x"A1",x"A1",x"A1",x"A1",x"A1",x"A1",x"A1",x"A2",x"A2",x"A2",x"A2",x"A2",x"A2",x"A2",x"A2",x"A3",x"A3",x"A3",x"A3",x"A3",x"A3",x"A3",x"A3",x"A4",x"A4",x"A4",x"A4",x"A4",x"A4",x"A4",x"A4",x"A5",x"A5",x"A5",x"A5",x"A5",x"A5",x"A5",x"A5",x"A6",x"A6",x"A6",x"A6",x"A6",x"A6",x"A6",x"A6",x"A7",x"A7",x"A7",x"A7",x"A7",x"A7",x"A7",x"A7",								x"A8",x"A8",x"A8",x"A8",x"A8",x"A8",x"A8",x"A8",x"A9",x"A9",x"A9",x"A9",x"A9",x"A9",x"A9",x"A9",x"AA",x"AA",x"AA",x"AA",x"AA",x"AA",x"AA",x"AA",x"AB",x"AB",x"AB",x"AB",x"AB",x"AB",x"AB",x"AB",x"AC",x"AC",x"AC",x"AC",x"AC",x"AC",x"AC",x"AC",x"AD",x"AD",x"AD",x"AD",x"AD",x"AD",x"AD",x"AD",x"AE",x"AE",x"AE",x"AE",x"AE",x"AE",x"AE",x"AE",x"AF",x"AF",x"AF",x"AF",x"AF",x"AF",x"AF",x"AF",								x"B0",x"B0",x"B0",x"B0",x"B0",x"B0",x"B0",x"B0",x"B1",x"B1",x"B1",x"B1",x"B1",x"B1",x"B1",x"B1",x"B2",x"B2",x"B2",x"B2",x"B2",x"B2",x"B2",x"B2",x"B3",x"B3",x"B3",x"B3",x"B3",x"B3",x"B3",x"FF",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",								x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00",x"00");
			
--  

type pushState_t is
	(
		WAIT_PUSH,PUSH_NEXT
	);

signal pushState		: pushState_t := WAIT_PUSH;
signal pushDataStore : std_logic_vector (31 downto 0) := (others => '0');

signal process_wdaddress		: std_logic_vector (10 downto 0) := (others => '0');
signal iwdaddress		: std_logic_vector (10 downto 0) := (others => '0');
signal we				: std_logic := '0';
signal r					: std_logic_vector(7 downto 0) := (others => '0');
signal g					: std_logic_vector(7 downto 0) := (others => '0');
signal b					: std_logic_vector(7 downto 0) := (others => '0');
			
begin

	-- not clk based ready update (Mealy State Machine for pushready)
	
	process ( pushState, pushin, pushmode )	
	begin
	
		-- default
	
		pushready	<= '1';
	
		case pushState is
				when WAIT_PUSH	=>		if pushin = '1' then
												case pushmode is
													when "00" =>																		
													when "01" | "10" | "11" =>	pushready	<= '0';	-- stall 																																		
													when others => -- modelsim
												end case;
											end if;
											
				when PUSH_NEXT	=>		
			end case;					
	end process;

	-- push processing
	
	process ( clk )	
	begin
		if rising_edge(clk) then
			
			-- address set 
			
			if setwaddress = '1' then
				process_wdaddress <= wdaddress;
			end if;
				
			-- data setup
		
				-- default
		
			we <= '0';
			r  <= (others => '0');
			g 	<= (others => '0');
			b  <= (others => '0');
			
			pushState 	<= WAIT_PUSH;	
			
				-- states
		
			case pushState is
				when WAIT_PUSH	=>		if pushin = '1' then
												case pushmode is
													when "00" =>	-- 8x8r8g8b
																		r 	<= pushdata(23 downto 16);
																		g 	<= pushdata(15 downto 8);
																		b 	<= pushdata(7 downto 0);
																		we	<= '1';
																		
																		process_wdaddress <= process_wdaddress + 1;
																		pushState <= WAIT_PUSH;	
																		
													when "01" =>	-- 5r6g5b 5r6g5b
																		-- 565
																		--
																		--33322222222221111111111
																		--10987654321098765432109876543210
																		--rrrrrggggggbbbbbrrrrrggggggbbbbb
																		
																		pushDataStore <= pushdata; -- store for next cycle
																		
																		r 	<= pushdata(31 downto 27) & "000";
																		g 	<= pushdata(26 downto 21) & "00";
																		b 	<= pushdata(20 downto 16) & "000";
																		we	<= '1';
																																				
																		process_wdaddress 	<= process_wdaddress + 1;
																		pushState 	<= PUSH_NEXT;	
																		
													when "10" =>	-- 5r5g5b 5r5g5b
																		-- 555
																		--
																		--33322222222221111111111
																		--10987654321098765432109876543210
																		---rrrrrgggggbbbbb-rrrrrgggggbbbbb
																		
																		pushDataStore <= pushdata; -- store for next cycle
																		
																		r 	<= pushdata(30 downto 26) & "000";
																		g 	<= pushdata(25 downto 21) & "000";
																		b 	<= pushdata(20 downto 16) & "000";
																		we	<= '1';
																																				
																		process_wdaddress 	<= process_wdaddress + 1;
																		pushState 	<= PUSH_NEXT;	
													when "11" =>	-- 4r4g4b 4r4g4b
																		-- 444
																		--
																		--33322222222221111111111
																		--10987654321098765432109876543210
																		------rrrrggggbbbb----rrrrggggbbbb
																		
																		pushDataStore <= pushdata; -- store for next cycle
																		
																		r 	<= pushdata(27 downto 24) & "0000";
																		g 	<= pushdata(23 downto 20) & "0000";
																		b 	<= pushdata(19 downto 16) & "0000";
																		we	<= '1';
																																				
																		process_wdaddress 	<= process_wdaddress + 1;
																		pushState 	<= PUSH_NEXT;						
													when others =>
												end case;
											end if;
											
				when PUSH_NEXT	=>		
				
												case pushmode is																
													when "01" =>	-- 5r6g5b 5r6g5b
																		-- 565
																		--
																		--33322222222221111111111
																		--10987654321098765432109876543210
																		--rrrrrggggggbbbbbrrrrrggggggbbbbb
																		
																		r 	<= pushDataStore(15 downto 11) & "000";
																		g 	<= pushDataStore(10 downto 5) & "00";
																		b 	<= pushDataStore(4 downto 0) & "000";
																		we	<= '1';
																		
																		process_wdaddress 	<= process_wdaddress + 1;
																		pushState 	<= WAIT_PUSH;	
														
													when "10" =>	-- 5r5g5b 5r5g5b
																		-- 555
																		--
																		--33322222222221111111111
																		--10987654321098765432109876543210
																		---rrrrrgggggbbbbb-rrrrrgggggbbbbb
																																				
																		r 	<= pushDataStore(14 downto 10) & "000";
																		g 	<= pushDataStore(9 downto 5) & "000";
																		b 	<= pushDataStore(4 downto 0) & "000";
																		we	<= '1';
																																				
																		process_wdaddress 	<= process_wdaddress + 1;
																		pushState 	<= WAIT_PUSH;	
																		
													when "11" =>	-- 4r4g4b 4r4g4b
																		-- 444
																		--
																		--33322222222221111111111
																		--10987654321098765432109876543210
																		------rrrrggggbbbb----rrrrggggbbbb
																		
																		
																		r 	<= pushDataStore(11 downto 8) & "0000";
																		g 	<= pushDataStore(7 downto 4) & "0000";
																		b 	<= pushDataStore(3 downto 0) & "0000";
																		we	<= '1';
																																				
																		process_wdaddress 	<= process_wdaddress + 1;
																		pushState 	<= WAIT_PUSH;	
													when others =>
												end case;
				
			end case;	

		-- last address out
		
		iwdaddress <= process_wdaddress;
			
		end if;
	end process;

	-- read
	
	process ( clk )	
	begin
		if rising_edge(clk) then
			q(23 downto 16) 	<= dr(conv_integer(rdaddress));
			q(15 downto 8)		<= dg(conv_integer(rdaddress));
			q(7 downto 0) 		<= db(conv_integer(rdaddress));
		end if;
	end process;
	
	-- write
	
	process ( clk )	
	begin
		if rising_edge(clk) then
			if we = '1' then
				dr(conv_integer(iwdaddress)) <= r;
				dg(conv_integer(iwdaddress)) <= g;
				db(conv_integer(iwdaddress)) <= b;
			end if;
		end if;
	end process;
	
	
end rtl;
