library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package video_package is

	-- 1440x900x60 -- 720x450 -- 360x225 --

	-- video sync etc.
	
	constant HSYNC_default 			: integer range 0 to 4095 := 152-1;	
	constant HSTART_default			: integer range 0 to 4095	:= 384-1;
	constant HMEMSTART_default		: integer range 0 to 4095	:= 382-1;
	constant HSTOP_default			: integer range 0 to 4095	:= 1824-1;
	constant HTOTAL_default			: integer range 0 to 4095	:= 1904-1;
	
	constant VSYNC_default			: integer range 0 to 2047	:= 3-1;	
	constant VSTART_default			: integer range 0 to 2047	:= 31-1;
	constant VSTOP_default			: integer range 0 to 2047	:= 931-1;
	constant VTOTAL_default			: integer range 0 to 2047	:= 932-1;	
	
	constant VIDEO_ON_default		: std_logic := '1';
	
	-- external load
	
	constant HLOADSTART_default	: integer range 0 to 4095  := 8;		-- external memory start
	constant HLOADSTOP_default		: integer range 0 to 4095  := 8+180;
	
	constant VLOADSTART_default	: integer range 0 to 4095  := 31-1;		-- external memory start
	constant VLOADSTOP_default		: integer range 0 to 4095  := 931-1; 
	constant VLOADNEXT_default		: integer range 0 to 4095  := 4;
	
	-- memory processing
	
	constant MEM_STARTADR_default		: std_logic_vector(31 downto 0) := x"f0000000";		-- external memory start
	constant MEM_LINEOFFSET_default	: std_logic_vector(31 downto 0) := ( others => '0');		
	constant MEM_MODE_default			: std_logic_vector(15 downto 0) := "0000000000000001";
	
	-- line cache
	
	constant lc_add_default		: std_logic_vector(31 DOWNTO 0) := x"00400000";
	constant lc_start_default	: std_logic_vector(10 DOWNTO 0) := ( others => '0');
	
end video_package;
