print "***********************************************************\n"
print "*               goldmomo endlos package build             *\n"
print "***********************************************************\n"
print "\n"

sZipExecPath = ENV['ProgramFiles'] + "\\7-Zip\\7z.exe"

if !File.exist?(sZipExecPath)
	print "Error: 7zip executable not found!\n"
	system("ping localhost -n 10\n")
	exit
end

rootDir 	= "F:\\git\\goldmomo_endlos\\";
currentDir	= rootDir + "\\packages";
sourceDir 	= rootDir + "\\assembler_files";
assemblerDir 	= rootDir + "Cross_Development\\ucore\\ucore_assembler_console\\ucore_assembler_console\\bin\\Release\\"

# packages

PackageStruct = Struct.new(:name, :iram, :sd, :flash);

# packages 

packages = 	[
	PackageStruct.new("SpacePilotOfDeath",		"ucore\\boot_level1_r2.s","ucore\\spacePilot_sdCard.s",			"..\\packages\\flash.raw"),
 	PackageStruct.new("SpacePilotOfDeathSE",	"ucore\\boot_level1_r2.s","ucore\\spacePilot_se_sdCard.s",		"..\\packages\\flash.raw"),
	PackageStruct.new("Sheriff2213",		"ucore\\boot_level1_r2.s","ucore\\Sheriff\\main_sd.s",			"..\\packages\\flash.raw"),
	PackageStruct.new("ModPlayer",			"ucore\\boot_level1_r2.s","ucore\\soundTest2_play_mod_sd_load.s",	"..\\packages\\flash.raw"),
	PackageStruct.new("Rotozoomer",			"ucore\\boot_level1_r2.s","ucore\\rotoZoomerTest1.s",			"..\\packages\\flash.raw"),
	PackageStruct.new("PictureSRAM",		"ucore\\pictureSRAM1.s","",						"..\\packages\\flash.raw"),
	PackageStruct.new("PictureSDRAM",		"ucore\\pictureSDRAM1.s","",						"..\\packages\\flash.raw"),
	PackageStruct.new("VGATest8",			"ucore\\vgaTest8.s","",							"..\\packages\\flash.raw"),
	PackageStruct.new("PS2Test",			"ucore\\consoleTest5_ps2_libTest.s","",					"..\\packages\\flash.raw"),
	PackageStruct.new("GFXExtension",		"ucore\\boot_level1_r2.s","ucore\\extensionL2DTest_3.s",		"..\\packages\\flash.raw"),
		
	];

packages.each do |p|
	Dir.chdir(currentDir);
	if Dir.exists?(p.name) == false	# create temporary dir
		Dir.mkdir(p.name);
	end
	Dir.chdir(assemblerDir);
	
	print "***********************************************************\n"
	print("****** make package " + p.name + "\n");
	print "***********************************************************\n"
	# build iram
	
	if(p.iram.length > 0)
		print("**** Build iram ****\n");
		system("ucore_assembler_console.exe -s " + sourceDir + "\\" + p.iram + " -o " + currentDir + "\\" + p.name + "\\iram" + " -sraw");
	end 
	
	# build sd
	
	if(p.sd.length > 0)
		print("**** Build sdcard ****\n");
		system("ucore_assembler_console.exe -s " + sourceDir + "\\" + p.sd + " -o " + currentDir + "\\" + p.name + "\\sdcard" + " -sraw -stnotfixed");
	end 
	
	#copy flash
	
	if(p.flash.length > 0)
		print("**** Copy flash ****\n");
		system("copy " + sourceDir + "\\" + p.flash + " " + currentDir + "\\" + p.name + "\\");
	end
	
	#generate xml
				
	print("**** Write config ****\n");
	xmlConfig = 
	"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n"+
	"<goldmomo_endlos>\n"+
	((p.flash.length > 0)?	"<flash_raw>flash.raw</flash_raw>\n":"")+
	((p.iram.length > 0)?	"<ucore_raw>iram.raw</ucore_raw>\n":"")+
	((p.sd.length > 0)?	"<sd_card>sdcard.raw</sd_card>\n":"")+
	"</goldmomo_endlos>\n"
	
	File.open(currentDir + "\\" + p.name + "\\config.xml", 'w') {|f| f.write(xmlConfig) }	
	
	
	
	#compress to zip
	
	Dir.chdir(currentDir);
	print("**** Make zip ****\n");
	if File.exists?(p.name + ".zip")
		print("delete old archive\n");
		File.delete(p.name + ".zip");		
	end
	Dir.chdir(currentDir + "\\" + p.name);
	system("\"" +sZipExecPath + "\" a -tzip -mx9 ..\\" + p.name + " *" + "\n")
		
	#remove temp dir
	Dir.chdir(currentDir);
	print("**** Remove temporary directory ****\n");
	system("rmdir /S /Q \"" + p.name + "\"\n")
	
end;






